function diffraction = DiffractionData (imagefile, savefile, horzline)
% this function takes an image file and returns a text file that contains
% the intensity data along a user inputted horizontal scan line. an example
% usage would be 

%DiffractionData('PoissonSpot.jpeg','poissonspot.txt', 250)

%This would import the image Poissonspot.jpeg and output the intensity as a
%function of pixel position along the y=250 horizontal line to the data
%file poissonspot.txt.

%The image files captured will usually be 480x640 (horizontal x vertical)

image = rgb2gray(imread(imagefile));
output = fopen(savefile,'w');

if (horzline >= 0) & (horzline <= 480)
    for j=1:640
        diffractionarray(1,j)=(j);
        diffractionarray(2,j)=(image(horzline,j));
    end

    fprintf(output,'\n %i, %i',diffractionarray(1:2,:));
    status = fclose('all');
    
end
    


