%This m-file will grab 240 seconds of video in a 10x10 pixel area specified
%by the user. The output (FringeAvg) is an sum of over 10x10 pixel area

nn=8000; %number of frames to capture. At 30 frames/sec this require a Timeout of
         %at least 240 seconds. See line 14 to adjust Timeout.

%%initialization of video card
info=imaqhwinfo;
info=imaqhwinfo('winvideo');
dev_info = imaqhwinfo('winvideo',1);
vid = videoinput('winvideo',1,'RGB24_752x480');
set(vid,'SelectedSourceName','composite')
set(vid,'TriggerRepeat',Inf);
set(vid,'ReturnedColorSpace','grayscale')
set(vid,'Timeout',280) %If you increase number of frames nn, then timeout should also increase
%%end initialization of video card

%%get initial snapshot to frame region of interest
frame = getsnapshot(vid);
figure(2)
imshow(frame)
ROI=ginput(1); % mouse input to select region of interest (ROI) with good fringe constrast
set(vid,'ROIPosition',[ROI 10 10]) % set ROI to be a 10x10 pixel region around mouse click
%%end get initial snapshot to frame region of interest
preview(vid)
%%prep card for grabbing data
vid_src = getselectedsource(vid);
set(vid_src,'Tag','test');
%%end prep card for grabbing data

crap=input('Now start the move sequence with APT User and quickly return to matlab and hit the <return> key');
%This pause is included to that you can manual start the move sequence of
%the stage via APT User and then return to matlab to continue (by hitting a key) and
%starting the image acquisition.

start(vid)

[data,time] = getdata(vid,nn);
stop(vid)
fringes=data(:,:,1,:);

%need to make sure that data is taken during the entirity of the stage
%motion, otherwise you wouldn't get a correct calibration.

%now the ROI of interested is averaged in case of bad pixels, etc.

FringeAvg=linspace(1,nn);

for i=1:nn
    FringeAvg(i)=sum(sum(fringes(:,:,1,i)));
end
figure(2)
plot(FringeAvg) 

% on this plot there should be a fixed value, 
%followed by fringes (oscillations) then a fixed value again. If not, then
%you haven't captured the entire motion of the stage



%clean up
stoppreview(vid)
delete(vid)
clear vid
