%This m-file will grab a frame and then plot a horizontal slice of the
%normalize pixel value. The process will be repeated until user quits. The
%subsequent slices will be plotted along with the current slice. The
%fringes should be vertical for this program to be useful

%%initialization of video card
info=imaqhwinfo;
info=imaqhwinfo('winvideo');
dev_info = imaqhwinfo('winvideo',1);
vid = videoinput('winvideo',1,'RGB24_752x480');
set(vid,'SelectedSourceName','composite')
set(vid,'TriggerRepeat',Inf);
set(vid,'ReturnedColorSpace','grayscale')

%%get initial snapshot to frame region of interest
frame = getsnapshot(vid);
figure(2)
imshow(frame)
% mouse input to select region of interest (ROI) with good fringe constrast
% requires two mouse clicks upper left and lower right to define ROI
vis_ROI=ginput(2)
ROIx_off=vis_ROI(1,1);
ROIy_off=vis_ROI(1,2);
ROIx_wid=vis_ROI(2,1)-ROIx_off;
ROIy_wid=vis_ROI(2,2)-ROIy_off;
set(vid,'ROIPosition',[ROIx_off ROIy_off ROIx_wid ROIy_wid]) 
%%end get initial snapshot to frame region of interest

preview(vid)

%now select horizontal slice location
frame = getsnapshot(vid);
figure(2)
imshow(frame)
slice_loc=ginput(1);

zero_path_slice=double(frame(round(slice_loc(1,2)),:));
norm_zero_path_slice=zero_path_slice/max(zero_path_slice);
%the norm_zero_path slice should be the position of highest visibility which should
%be where the white light fringes are located 

slice_dim=size(frame);
slice_x=slice_dim(1,2);
slice_x_index=linspace(0,slice_x,slice_x);
figure(3)
plot(slice_x_index,norm_zero_path_slice);

reply='Y';

while(strncmp(reply, 'Y',1))
%in the while loop move the stage until the visibility is decreased by 50%
%after that point you can exit the loop
    frame=getsnapshot(vid);
    new_slice=double(frame(round(slice_loc(1,2)),:));
    norm_new_slice=new_slice/max(new_slice);
    figure(3);
    plot(slice_x_index,norm_zero_path_slice,slice_x_index,norm_new_slice,'r');
    reply = input('If you want to keep going hit <enter>, else hit any key ', 's');
    if isempty(reply)
        reply='Y';
    else
        reply='N';
    end
end

    
stoppreview(vid)
delete(vid)
clear vid
